import React, {Component} from 'react'
import { Menu } from 'antd'
import { fromJS } from 'immutable'
import { FolderOutlined } from '@ant-design/icons'

import { SySMenuList } from './config'
import MKEmitter from '@/utils/events.js'
import './index.scss'

const { SubMenu } = Menu

class Sidemenu extends Component {
  state = {
    subMenulist: [],         // 二级菜单
    rootSubmenuKeys: [],
    openKeys: []
  }

  changemenu(e, menu) {
    e.preventDefault()

    MKEmitter.emit('modifyTabs', menu)
  }

  componentDidMount () {
    let menulist = SySMenuList

    if (window.GLOB.systemType === 'production') {
      menulist.forEach(menu => {
        menu.children = menu.children.filter(item => item.systems && item.systems.includes(window.GLOB.systemType))
      })

      menulist = menulist.filter(menu => menu.children.length > 0)
    } else {
      menulist.forEach(menu => {
        menu.children = menu.children.filter(item => !item.systems || item.systems.includes(window.GLOB.sysType))
      })

      menulist = menulist.filter(menu => menu.children.length > 0)
    }

    let tb =  sessionStorage.getItem('mk-table-node')

    this.setState({
      subMenulist: menulist,
      rootSubmenuKeys: menulist.map(item => item.MenuID),
      openKeys: [menulist[0].MenuID]
    }, () => {
      if (tb && menulist[0] && menulist[0].children[0] && menulist[0].children[0].MenuNo === 'sDatasM') {
        setTimeout(() => {
          MKEmitter.emit('modifyTabs', fromJS(menulist[0].children[0]).toJS())
        }, 500)
      }
      sessionStorage.removeItem('mk-table-node')
    })
  }

  onOpenChange = openKeys => {
    const latestOpenKey = openKeys.find(key => this.state.openKeys.indexOf(key) === -1)
    if (this.state.rootSubmenuKeys.indexOf(latestOpenKey) === -1) {
      this.setState({ openKeys })
    } else {
      this.setState({
        openKeys: latestOpenKey ? [latestOpenKey] : []
      })
    }
  }

  render () {
    return (
      <aside className="mk-sys-side-menu ant-menu-dark mk-edit">
        <Menu openKeys={this.state.openKeys} onOpenChange={this.onOpenChange} mode="inline" theme="dark">
        {this.state.subMenulist && this.state.subMenulist.map((item, index) => {
          return (
            <SubMenu
              key={item.MenuID}
              title={
                <span><FolderOutlined /> {item.MenuName}</span>
              }
            >
              {item.children.map(cell => {
                return (
                  <Menu.Item key={cell.MenuID}>
                    <a href={cell.src} id={cell.MenuID} onClick={(e) => this.changemenu(e, cell)}>{cell.MenuName}</a>
                  </Menu.Item>
                )
              })}
            </SubMenu>
          )
        })}
      </Menu>
        
      </aside>
    )
  }
}

export default Sidemenu